#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){
    ofEnableAlphaBlending();
	ofBackground(0,0,0);

	ofSetVerticalSync(true);
	ofSetFrameRate(60);


	for (int i = 0; i < 20; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(500,550),ofRandom(500,550),0,0);
		particles.push_back(myParticle);
	}

	for (int i = 0; i < (particles.size()); i++){
		spring mySpring;
		mySpring.distance		= 5;
		mySpring.springiness	= 0.7f;
		mySpring.particleA = & (particles[i]);
		mySpring.particleB = & (particles[(i+1)%particles.size()]);
		springs.push_back(mySpring);
	}

	//particles[particles.size()-1].bFixed = true;

}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update

	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}


	for (int i = 0; i < particles.size(); i++){
		//particles[i].addForce(0,0.1);

		for (int j = 0; j < i; j++){
			particles[i].addRepulsionForce(particles[j], 20, 0.03);
		}

	}


	for (int i = 0; i < springs.size(); i++){
		springs[i].update();
	}


	for (int i = 0; i < particles.size(); i++){
		particles[i].addDampingForce();

		particles[i].update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){

 for(int x=0; x<5; x++){
	ofSetColor(255,2,122,10);

	ofBeginShape();
	ofFill();
	for (int i = 0; i < particles.size(); i++){
		//particles[i].draw();
		ofVertex(particles[i].pos.x,particles[i].pos.y);
		//ofVertex(particles[0].pos.x,particles[0].pos.x);
	}

	for (int i = 0; i < springs.size(); i++){
		springs[i].draw();
	}

	ofEndShape(true);
 }
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){

	switch (key){

		case ' ':
			// reposition everything:
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
	}


}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	particles[0].pos.set(mouseX, mouseY);
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	particles[0].bFixed = true;
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	particles[0].bFixed = false;
}

